glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::IOStream Class Reference
Stream Classes

IOStream - Base class for implementing read/write streams. More...

`#include <giomm/iostream.h>`

Inheritance diagram for Gio::IOStream:
[legend]

## Public Member Functions
| IOStream (IOStream&& src) noexcept
IOStream& | operator= (IOStream&& src) noexcept
| ~IOStream () noexcept override
GIOStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream* | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous io stream splice operation. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Detailed Description

IOStream - Base class for implementing read/write streams.

IOStream represents an object that has both read and write streams. Generally the two streams acts as separate input and output streams, but they share some common resources and state. For instance, for seekable streams they may use the same position in both streams.

Examples of IOStream objects are SocketConnection which represents a two-way network connection, and FileIOStream which represent a file handle opened in read-write mode.

To do the actual reading and writing you need to get the substreams with get_input_stream() and get_output_stream().

The IOStream object owns the input and the output streams, not the other way around, so keeping the substreams alive will not keep the IOStream object alive. If the IOStream object is freed it will be closed, thus closing the substream, so even if the substreams stay alive they will always just return a Gio::IO_ERROR_CLOSED for all operations.

To close a stream use close() which will close the common stream object and also the individual substreams. You can also close the substreams themselves. In most cases this only marks the substream as closed, so further I/O on it fails. However, some streams may support "half-closed" states where one direction of the stream is actually shut down.

Since glibmm 2.22:

## Constructor & Destructor Documentation

## ◆ IOStream()

Gio::IOStream::IOStream | ( | IOStream&& | src | ) |
| noexcept

## ◆ ~IOStream()

Gio::IOStream::~IOStream | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ clear_pending()

void Gio::IOStream::clear_pending | ( |  | ) |

Clears the pending flag on stream.

Since glibmm 2.22:

## ◆ close() [1/2]

bool Gio::IOStream::close | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Closes the stream, releasing resources related to it.

This will also close the individual input and output streams, if they are not already closed.

Once the stream is closed, all other operations will return IO_ERROR_CLOSED. Closing a stream multiple times will not return an error.

Closing a stream will automatically flush any outstanding buffers in the stream.

Streams will be automatically closed when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

Some streams might keep the backing store of the stream (e.g. a file descriptor) open after the stream is closed. See the documentation for the individual stream for details.

On failure the first error that happened will be reported, but the close operation will finish as much as possible. A stream that failed to close will still return IO_ERROR_CLOSED for all operations. Still, it is important to check and report the error to the user, otherwise there might be a loss of data as all data might not be written.

If cancellable is not `nullptr`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error IO_ERROR_CANCELLED will be returned. Cancelling a close will still leave the stream closed, but some streams can use a faster close that doesn't block to e.g. check errors.

The default implementation of this method just calls close on the individual input/output streams.

Since glibmm 2.22:

Parameters

  cancellable | Optional Cancellable object, `nullptr` to ignore.

Returns
  `true` on success, `false` on failure.

Exceptions

  Glib::Error |

## ◆ close() [2/2]

bool Gio::IOStream::close | ( |  | ) |

A close() convenience overload.

## ◆ close_async() [1/2]

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

## ◆ close_async() [2/2]

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

## ◆ close_finish()

bool Gio::IOStream::close_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Closes a stream.

Since glibmm 2.22:

Parameters

  result | A AsyncResult.

Returns
  `true` if stream was successfully closed, `false` otherwise.

Exceptions

  Glib::Error |

## ◆ get_input_stream()

Glib::RefPtr<InputStream> Gio::IOStream::get_input_stream | ( |  | ) |

Gets the input stream for this object.

This is used for reading.

Since glibmm 2.22:

Returns
  A InputStream, owned by the IOStream. Do not free.

## ◆ get_output_stream()

Glib::RefPtr<OutputStream> Gio::IOStream::get_output_stream | ( |  | ) |

Gets the output stream for this object.

This is used for writing.

Since glibmm 2.22:

Returns
  A OutputStream, owned by the IOStream. Do not free.

## ◆ get_type()

static GType Gio::IOStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GIOStream* Gio::IOStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GIOStream* Gio::IOStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GIOStream* Gio::IOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ has_pending()

bool Gio::IOStream::has_pending | ( |  | ) | const

Checks if a stream has pending actions.

Since glibmm 2.22:

Returns
  `true` if stream has pending actions.

## ◆ is_closed()

bool Gio::IOStream::is_closed | ( |  | ) | const

Checks if a stream is closed.

Since glibmm 2.22:

Returns
  `true` if the stream is closed.

## ◆ operator=()

IOStream& Gio::IOStream::operator= | ( | IOStream&& | src | ) |
| noexcept

## ◆ set_pending()

bool Gio::IOStream::set_pending | ( |  | ) |

Sets stream to have actions pending.

If the pending flag is already set or stream is closed, it will return `false` and set error.

Since glibmm 2.22:

Returns
  `true` if pending was previously unset and is now set.

Exceptions

  Glib::Error |

## ◆ splice_async() [1/2]

void Gio::IOStream::splice_async | ( | const Glib::RefPtr< IOStream >& | stream2,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | IOStreamSpliceFlags | flags = `Gio::IO_STREAM_SPLICE_NONE`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream.

When the operation is finished slot will be called. You can then call splice_finish() to get the result of the operation.

Parameters

  stream2 | The second IOStream.
  slot | A SlotAsyncReady slot.
  cancellable | A Cancellable object.
  flags | A set of IOStreamSpliceFlags.
  io_priority | The io priority of the request.

Since glibmm 2.34:

## ◆ splice_async() [2/2]

void Gio::IOStream::splice_async | ( | const Glib::RefPtr< IOStream >& | stream2,
|  | const SlotAsyncReady& | slot,
|  | IOStreamSpliceFlags | flags = `Gio::IO_STREAM_SPLICE_NONE`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

A non-cancellable version of splice_async().

## ◆ splice_finish()

static bool Gio::IOStream::splice_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |
| static

Finishes an asynchronous io stream splice operation.

Since glibmm 2.28:

Parameters

  result | A AsyncResult.

Returns
  `true` on success, `false` otherwise.

Exceptions

  Glib::Error |

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::IOStream > wrap | ( | GIOStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.